#include <iostream>

#include "TRandom.h"

#include "Event_CStyleArray.h"

void Pulse_CStyleArray::Clear(Option_t *)
{
	TObject::Clear();
}

void Pulse_CStyleArray::Random()
{
	fRate = 50*(1+gRandom->Integer(10));
	if (gRandom->Integer(2) == 0) {
		fPolarity = false;
	} else {
		fPolarity = true;
	}
	fPrePulseLength = gRandom->Integer(50);
	fChannelID = gRandom->Integer(5);
	fBaseline = 3000+500*Float_t(gRandom->Rndm());
	for (int i = 0; i < fNSamples; i++) {
		fSamples[i] = UShort_t(fBaseline)-25+gRandom->Integer(50);
	}
	fPulseTime = Float_t(gRandom->Rndm())*fNSamples*fRate;
	fAmplitude = Float_t(gRandom->Rndm())*100;
	fPSD = Float_t(gRandom->Rndm())*100;
}

Event_CStyleArray::Event_CStyleArray()
{
	fPulses = new TClonesArray("Pulse_CStyleArray", 100);
	fNPulses = 0;
}

Event_CStyleArray::~Event_CStyleArray()
{
}

void Event_CStyleArray::Clear(Option_t *)
{
	fNPulses = 0;
	fPulses->Clear("C"); // Calls Pulses::Clear
}

void Event_CStyleArray::Build(UInt_t ev)
{
	fTemperature = 80.0+gRandom->Rndm()*10;
	fTimeStamp = ev*10;
	fEventStamp = ev;
  Clear();
}

Pulse_CStyleArray *Event_CStyleArray::AddPulse()
{
	Pulse_CStyleArray *pulse = (Pulse_CStyleArray*)fPulses->ConstructedAt(fNPulses++);
	pulse->Random();
	return pulse;
}
