#ifndef ROOT_EVENTCSTYLEArray
#define ROOT_EVENTCSTYLEARRAY

#include "TObject.h"
#include "TClonesArray.h"

#include "DllExport.h"

//class rootFileTest_lib_EXPORT Pulse_VarArray : public TObject {
class Pulse_VarArray : public TObject {
private:
	// Raw stored values
	UShort_t	fRate;
	Bool_t		fPolarity;
	UShort_t	fPrePulseLength;
	UShort_t	fChannelID;
	Int_t	fNSamples;
	UShort_t	*fSamples; //[fNSamples]
	// Calculated values
	Float_t		fPulseTime;
	Float_t		fBaseline;
	Float_t		fAmplitude;
	Float_t		fPSD;

public:
	Pulse_VarArray() : fNSamples(100) { fSamples = new UShort_t[fNSamples]; }
	virtual ~Pulse_VarArray() { Clear(); delete[] fSamples; }

	void		Clear(Option_t *option="");
	UShort_t	GetRate() const { return fRate; }
	Bool_t		GetPolarity() const { return fPolarity; }
	UShort_t	GetPrePulseLength() const { return fPrePulseLength; }
	UShort_t	GetChannelID() const { return fChannelID; }
	const UShort_t operator[](UShort_t i) { return fSamples[i]; }

	Float_t		GetPulseTime() const { return fPulseTime; }
	Float_t		GetBaseline() const { return fBaseline; }
	Float_t		GetAmplitude() const { return fAmplitude; }
	Float_t		GetPSD() const { return fPSD; }

	void		Random();

	ClassDef(Pulse_VarArray, 1)
};

//class rootFileTest_lib_EXPORT Event_VarArray : public TObject {
class Event_VarArray : public TObject {
private:
	char fType[20];
	Double32_t		fTemperature;
	ULong_t			fTimeStamp;
	ULong_t			fEventStamp;
	UInt_t			fNPulses;
	TClonesArray	*fPulses; //->

public:
	Event_VarArray();
	virtual ~Event_VarArray();
	void	Build(UInt_t ev);
	void	Clear(Option_t *option = "");

	void	SetTemperature(Double32_t t) { fTemperature = t; }
	void	SetTimeStamp(ULong_t t) { fTimeStamp = t; }
	void	SetEventStamp(ULong_t e) { fEventStamp = e; }
	Pulse_VarArray	*AddPulse();
	void	SetType(char *type) { strcpy(fType, type); }

	char	*GetType() { return fType; }
	Double32_t GetTemperature() const { return fTemperature; }
	ULong_t	GetTimeStamp() const { return fTimeStamp; }
	UInt_t	GetNPulses() const { return fNPulses; }
	TClonesArray *GetPulses() const { return fPulses; }

	ClassDef(Event_VarArray, 1)
};
#endif
