# MACRO_ENSURE_OUT_OF_SOURCE_BUILD(<errorMessage>)

macro(MACRO_ENSURE_OUT_OF_SOURCE_BUILD)
string(COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" _insource)
if(_insource)
  message( FATAL_ERROR "
  ****************************************************************************
  In-source builds are NOT allowed as CMake will overwrite existing Makefiles
  Please either run from <repo>/cmake or an out of source directory.
  Run the following commands to remove 'CMakeCache.txt' and 'CMakeFiles/'
  rm -rf ${CMAKE_SOURCE_DIR}/CMakeCache.txt
  rm -rf ${CMAKE_SOURCE_DIR}/CMakeFiles/
  rm -rf ${CMAKE_SOURCE_DIR}/*/CMakeCache.txt
  rm -rf ${CMAKE_SOURCE_DIR}/*/CMakeFiles/
  ****************************************************************************\n"
  )
endif(_insource)
endmacro(MACRO_ENSURE_OUT_OF_SOURCE_BUILD)
